;*---------------------------------------------------------------------*/
;*    Copyright (c) 1994 by Manuel Serrano. All rights reserved.       */
;*                                                                     */
;*                                     ,--^,                           */
;*                               _ ___/ /|/                            */
;*                           ,;'( )__, ) '                             */
;*                          ;;  //   L__.                              */
;*                          '   \    /  '                              */
;*                               ^   ^                                 */
;*                                                                     */
;*                                                                     */
;*    This program is distributed in the hope that it will be useful.  */
;*    Use and copying of this software and preparation of derivative   */
;*    works based upon this software are permitted, so long as the     */
;*    following conditions are met:                                    */
;*           o credit to the authors is acknowledged following         */
;*             current academic behaviour                              */
;*           o no fees or compensation are charged for use, copies,    */
;*             or access to this software                              */
;*           o this copyright notice is included intact.               */
;*      This software is made available AS IS, and no warranty is made */
;*      about the software or its performance.                         */
;*                                                                     */
;*      Bug descriptions, use reports, comments or suggestions are     */
;*      welcome Send them to                                           */
;*        <Manuel.Serrano@inria.fr>                                    */
;*        Manuel Serrano                                               */
;*        INRIA -- Rocquencourt                                        */
;*        Domaine de Voluceau, BP 105                                  */
;*        78153 Le Chesnay Cedex                                       */
;*        France                                                       */
;*---------------------------------------------------------------------*/


;; Le module                                                                 
(module
  __caml_trstream
  (foreign (include #"caml-bigloo.h"))
  (import
    (__caml_const #"const.scm")
    (__caml_tr_env #"tr_env.scm")
    (__caml_match #"match.scm")
    (__caml_lambda #"lambda.scm")
    (__caml_prim #"prim.scm")
    (__caml_globals #"globals.scm")
    (__caml_syntax #"syntax.scm")
    (__caml_misc #"misc.scm"))
  (export
    sempty_tag_189@trstream
    scons_tag_245@trstream
    sapp_tag_42@trstream
    sfunc_tag_64@trstream
    parse_failure_tag_183@trstream
    (translate_stream_2@trstream x1)
    (3-121-translate_stream_2@trstream x1 x2 x3)
    (stream_oper_137@trstream x1)
    (stream_raise_169@trstream x1)
    (2-49-stream_raise_169@trstream x1 x2)
    raise_parse_failure_133@trstream
    raise_parse_error_213@trstream
    (catch_parse_failure_60@trstream x1)
    (divide_term_parsing_216@trstream x1)
    access_stream_157@trstream
    (translate_parser_248@trstream x1)
    (4-247-translate_parser_248@trstream x1 x2 x3 x4)))
;; L'initialisation du module                                                
(init_camloo!)
;; Les variables globales                                                    
;; Les expressions globales                                                  
(begin
  (define sempty_tag_189@trstream
    (caml-make-regular
      (caml-make-tag 1 2)
      3
      (caml-make-regular
        (caml-make-tag 0 0)
        2
        #"builtin"
        #"Sempty")
      0
      5))
 (begin
    (define scons_tag_245@trstream
      (caml-make-regular
        (caml-make-tag 1 2)
        3
        (caml-make-regular
          (caml-make-tag 0 0)
          2
          #"builtin"
          #"Scons")
        1
        5))
   (begin
      (define sapp_tag_42@trstream
        (caml-make-regular
          (caml-make-tag 1 2)
          3
          (caml-make-regular
            (caml-make-tag 0 0)
            2
            #"builtin"
            #"Sapp")
          2
          5))
     (define sfunc_tag_64@trstream
        (caml-make-regular
          (caml-make-tag 1 2)
          3
          (caml-make-regular
            (caml-make-tag 0 0)
            2
            #"builtin"
            #"Sfunc")
          3
          5))
)))
(define parse_failure_tag_183@trstream 10)
(begin
  (define translate_stream_2@trstream
    (lambda (x1)
      (lambda (x2)
        (lambda (x3)
          (3-121-translate_stream_2@trstream x1 x2 x3)))))
 (define 3-121-translate_stream_2@trstream
    (lambda (x1 x2 x3)
      (letrec ((x4 (lambda (x5)
                     (lambda (x6)
                       (if (null? x6)
                         (caml-make-regular
                           (caml-make-tag 1 19)
                           1
                           (caml-make-regular
                             (caml-make-tag 1 2)
                             2
                             sempty_tag_189@trstream
                             '()))
                         (labels
                           ((staticfail1000
                              ()
                              (let ((x7 (let ((x7 (car x6)))
                                          (case (caml-regular-constr-tag x7)
                                            ((1) scons_tag_245@trstream)
                                            (else sapp_tag_42@trstream)))))
                                (let ((x8 (let ((x8 (car x6)))
                                            (case (caml-regular-constr-tag x8)
                                              ((1) (caml-constr-get-field x8 0))
                                              (else
                                               (caml-constr-get-field x8 0))))))
                                  (caml-make-regular
                                    (caml-make-tag 6 19)
                                    2
                                    (caml-make-regular
                                      (caml-make-tag 6 38)
                                      1
                                      sfunc_tag_64@trstream)
                                    (cons (caml-make-regular
                                            (caml-make-tag 3 19)
                                            1
                                            (caml-make-regular
                                              (caml-make-tag 6 19)
                                              2
                                              (caml-make-regular
                                                (caml-make-tag 6 38)
                                                1
                                                x7)
                                              (cons ((x1 (caml-make-regular
                                                           (caml-make-tag 1 3)
                                                           1
                                                           x5))
                                                     x8)
                                                    (cons ((x4 (caml-make-regular
                                                                 (caml-make-tag
                                                                   1
                                                                   3)
                                                                 1
                                                                 x5))
                                                           (cdr x6))
                                                          '()))))
                                          (cons (caml-make-regular
                                                  (caml-make-tag 1 19)
                                                  1
                                                  const_unit_249@const)
                                                '())))))))
                           (case (if (caml-constant-constr? (car x6))
                                   -1
                                   (caml-regular-constr-tag (car x6)))
                             ((2)
                              (if (null? (cdr x6))
                                (caml-make-regular
                                  (caml-make-tag 6 19)
                                  2
                                  (caml-make-regular
                                    (caml-make-tag 6 38)
                                    1
                                    sfunc_tag_64@trstream)
                                  (cons (caml-make-regular
                                          (caml-make-tag 3 19)
                                          1
                                          ((x1 (caml-make-regular
                                                 (caml-make-tag 1 3)
                                                 1
                                                 x5))
                                           (caml-constr-get-field (car x6) 0)))
                                        (cons (caml-make-regular
                                                (caml-make-tag 1 19)
                                                1
                                                const_unit_249@const)
                                              '())))
                                (staticfail1000)))
                             (else (staticfail1000)))))))))
        ((x4 x2) x3))))
)
(define stream_oper_137@trstream
  (lambda (x1)
    (caml-make-regular
      (caml-make-tag 6 19)
      2
      (caml-make-regular
        (caml-make-tag 1 38)
        1
        (caml-make-regular
          (caml-make-tag 0 0)
          2
          #"stream"
          x1))
      '())))

(begin
  (define stream_raise_169@trstream
    (lambda (x1)
      (lambda (x2)
        (2-49-stream_raise_169@trstream x1 x2))))
 (define 2-49-stream_raise_169@trstream
    (lambda (x1 x2)
      (caml-make-regular
        (caml-make-tag 6 19)
        2
        (caml-make-tag 11 38)
        (cons (caml-make-regular
                (caml-make-tag 1 19)
                1
                (caml-make-regular
                  (caml-make-tag 1 2)
                  2
                  (caml-make-regular
                    (caml-make-tag 0 2)
                    2
                    (caml-make-regular
                      (caml-make-tag 0 0)
                      2
                      #"stream"
                      x1)
                    x2)
                  '()))
              '()))))
)
(begin
  (define raise_parse_failure_133@trstream
    ((stream_raise_169@trstream #"Parse_failure") 1))
 (define raise_parse_error_213@trstream
    ((stream_raise_169@trstream #"Parse_error") 2))
)
(define catch_parse_failure_60@trstream
  (lambda (x1)
    (caml-make-regular
      (caml-make-tag 11 19)
      2
      x1
      (caml-make-regular
        (caml-make-tag 12 19)
        3
        (caml-make-regular
          (caml-make-tag 6 19)
          2
          (caml-make-regular
            (caml-make-tag 5 38)
            1
            (caml-make-tag 0 6))
          (cons (caml-make-regular
                  (caml-make-tag 6 19)
                  2
                  (caml-make-tag 7 38)
                  (cons (caml-make-regular (caml-make-tag 0 19) 1 0)
                        '()))
                (cons (caml-make-regular
                        (caml-make-tag 1 19)
                        1
                        (caml-make-regular
                          (caml-make-tag 0 2)
                          1
                          (caml-make-regular
                            (caml-make-tag 0 4)
                            1
                            parse_failure_tag_183@trstream)))
                      '())))
        (caml-make-tag 9 19)
        (caml-make-regular
          (caml-make-tag 6 19)
          2
          (caml-make-tag 11 38)
          (cons (caml-make-regular (caml-make-tag 0 19) 1 0)
                '()))))))

(define divide_term_parsing_216@trstream
  (lambda (x1)
    (labels
      ((staticfail1001
         ()
         (caml-make-regular (caml-make-tag 0 1) 2 '() x1)))
      (if (null? x1)
        (staticfail1001)
        (if (null? (caml-constr-get-field (car x1) 0))
          (staticfail1001)
          (case (if (caml-constant-constr?
                      (car (caml-constr-get-field (car x1) 0)))
                  -1
                  (caml-regular-constr-tag
                    (car (caml-constr-get-field (car x1) 0))))
            ((1)
             (let ((x2 (divide_term_parsing_216@trstream (cdr x1))))
               (caml-make-regular
                 (caml-make-tag 0 1)
                 2
                 (cons (caml-make-regular
                         (caml-make-tag 0 1)
                         2
                         (caml-constr-get-field
                           (car (caml-constr-get-field (car x1) 0))
                           0)
                         (caml-make-regular
                           (caml-make-tag 0 1)
                           2
                           (cdr (caml-constr-get-field (car x1) 0))
                           (caml-constr-get-field (car x1) 1)))
                       (caml-constr-get-field x2 0))
                 (caml-constr-get-field x2 1))))
            (else (staticfail1001))))))))

(define access_stream_157@trstream
  (translate_access_117@tr_env #"%stream"))

(begin
  (define translate_parser_248@trstream
    (lambda (x1)
      (lambda (x2)
        (lambda (x3)
          (lambda (x4)
            (4-247-translate_parser_248@trstream x1 x2 x3 x4))))))
 (define 4-247-translate_parser_248@trstream
    (lambda (x1 x2 x3 x4)
      (letrec ((x5 (lambda (x6)
                     (lambda (x7)
                       (let ((x8 (caml-constr-get-field x7 0)))
                         (if (null? x8)
                           ((x1 x6) (caml-constr-get-field x7 1))
                           (case (caml-regular-constr-tag (car x8))
                             ((1)
                              (let ((x9 ((add_pat_to_env_200@tr_env x6)
                                         (caml-constr-get-field (car x8) 0))))
                                (caml-make-regular
                                  (caml-make-tag 4 19)
                                  2
                                  (cons (caml-make-regular
                                          (caml-make-tag 2 19)
                                          2
                                          (stream_oper_137@trstream
                                            #"stream_require")
                                          (cons (access_stream_157@trstream x6)
                                                '()))
                                        '())
                                  (((translate_matching_84@match
                                      (lambda (x10)
                                        raise_parse_error_213@trstream))
                                    x2)
                                   (cons (caml-make-regular
                                           (caml-make-tag 0 1)
                                           2
                                           (cons (caml-constr-get-field
                                                   (car x8)
                                                   0)
                                                 '())
                                           ((caml-constr-get-field x9 1)
                                            (caml-make-regular
                                              (caml-make-tag 13 19)
                                              2
                                              (caml-make-regular
                                                (caml-make-tag 2 19)
                                                2
                                                (stream_oper_137@trstream
                                                  #"stream_junk")
                                                (cons (access_stream_157@trstream
                                                        (caml-constr-get-field
                                                          x9
                                                          0))
                                                      '()))
                                              ((x5 (caml-constr-get-field x9 0))
                                               (caml-make-regular
                                                 (caml-make-tag 0 1)
                                                 2
                                                 (cdr x8)
                                                 (caml-constr-get-field
                                                   x7
                                                   1))))))
                                         '())))))
                             ((2)
                              (let ((x9 ((add_pat_to_env_200@tr_env x6)
                                         (caml-constr-get-field (car x8) 1))))
                                (caml-make-regular
                                  (caml-make-tag 4 19)
                                  2
                                  (cons (caml-make-regular
                                          (caml-make-tag 2 19)
                                          2
                                          (stream_oper_137@trstream
                                            #"parser_require")
                                          (cons ((x1 x6)
                                                 (caml-constr-get-field
                                                   (car x8)
                                                   0))
                                                (cons (access_stream_157@trstream
                                                        x6)
                                                      '())))
                                        '())
                                  (((translate_matching_84@match
                                      (lambda (x10)
                                        raise_parse_error_213@trstream))
                                    x2)
                                   (cons (caml-make-regular
                                           (caml-make-tag 0 1)
                                           2
                                           (cons (caml-constr-get-field
                                                   (car x8)
                                                   1)
                                                 '())
                                           ((caml-constr-get-field x9 1)
                                            ((x5 (caml-constr-get-field x9 0))
                                             (caml-make-regular
                                               (caml-make-tag 0 1)
                                               2
                                               (cdr x8)
                                               (caml-constr-get-field x7 1)))))
                                         '())))))
                             (else
                              (caml-make-regular
                                (caml-make-tag 4 19)
                                2
                                (cons (access_stream_157@trstream x6) '())
                                ((x5 (caml-make-regular
                                       (caml-make-tag 2 3)
                                       2
                                       (cons (caml-make-regular
                                               (caml-make-tag 0 1)
                                               2
                                               (caml-constr-get-field
                                                 (car x8)
                                                 0)
                                               (caml-make-tag 0 2))
                                             '())
                                       x6))
                                 (caml-make-regular
                                   (caml-make-tag 0 1)
                                   2
                                   (cdr x8)
                                   (caml-constr-get-field x7 1))))))))))))
        (letrec ((x6 (lambda (x7)
                       (lambda (x8)
                         (let ((x9 x8))
                           (if (null? x9)
                             raise_parse_failure_133@trstream
                             (if (null? (caml-constr-get-field (car x9) 0))
                               ((x1 x7) (caml-constr-get-field (car x9) 1))
                               (case (caml-regular-constr-tag
                                       (car (caml-constr-get-field (car x9) 0)))
                                 ((1)
                                  (let ((x10 (lambda (x10)
                                               (let ((x11 ((add_pat_to_env_200@tr_env
                                                             x7)
                                                           (caml-constr-get-field
                                                             x10
                                                             0))))
                                                 (caml-make-regular
                                                   (caml-make-tag 0 1)
                                                   2
                                                   (cons (caml-constr-get-field
                                                           x10
                                                           0)
                                                         '())
                                                   ((caml-constr-get-field
                                                      x11
                                                      1)
                                                    (caml-make-regular
                                                      (caml-make-tag 13 19)
                                                      2
                                                      (caml-make-regular
                                                        (caml-make-tag 2 19)
                                                        2
                                                        (stream_oper_137@trstream
                                                          #"stream_junk")
                                                        (cons (access_stream_157@trstream
                                                                (caml-constr-get-field
                                                                  x11
                                                                  0))
                                                              '()))
                                                      ((x5 (caml-constr-get-field
                                                             x11
                                                             0))
                                                       (caml-constr-get-field
                                                         x10
                                                         1)))))))))
                                    (let ((x11 (divide_term_parsing_216@trstream
                                                 x8)))
                                      (labels
                                        ((staticfail1002
                                           ()
                                           (caml-make-regular
                                             (caml-make-tag 10 19)
                                             2
                                             (caml-make-regular
                                               (caml-make-tag 4 19)
                                               2
                                               (cons (catch_parse_failure_60@trstream
                                                       (caml-make-regular
                                                         (caml-make-tag 2 19)
                                                         2
                                                         (stream_oper_137@trstream
                                                           #"stream_peek")
                                                         (cons (access_stream_157@trstream
                                                                 x7)
                                                               '())))
                                                     '())
                                               (((translate_matching_84@match
                                                   (lambda (x12)
                                                     (caml-make-tag 9 19)))
                                                 x2)
                                                ((map_118@list x10)
                                                 (caml-constr-get-field
                                                   x11
                                                   0))))
                                             ((x6 (caml-make-regular
                                                    (caml-make-tag 1 3)
                                                    1
                                                    x7))
                                              (caml-constr-get-field x11 1)))))
                                        (if (null? (caml-constr-get-field
                                                     x11
                                                     1))
                                          (caml-make-regular
                                            (caml-make-tag 4 19)
                                            2
                                            (cons (caml-make-regular
                                                    (caml-make-tag 2 19)
                                                    2
                                                    (stream_oper_137@trstream
                                                      #"stream_peek")
                                                    (cons (access_stream_157@trstream
                                                            x7)
                                                          '()))
                                                  '())
                                            (((translate_matching_84@match
                                                (lambda (x12)
                                                  raise_parse_failure_133@trstream))
                                              x2)
                                             ((map_118@list x10)
                                              (caml-constr-get-field x11 0))))
                                          (staticfail1002))))))
                                 ((2)
                                  (labels
                                    ((staticfail1003
                                       ()
                                       (let ((x10 ((add_pat_to_env_200@tr_env
                                                     x7)
                                                   (caml-constr-get-field
                                                     (car (caml-constr-get-field
                                                            (car x9)
                                                            0))
                                                     1))))
                                         (caml-make-regular
                                           (caml-make-tag 10 19)
                                           2
                                           (caml-make-regular
                                             (caml-make-tag 4 19)
                                             2
                                             (cons (catch_parse_failure_60@trstream
                                                     (caml-make-regular
                                                       (caml-make-tag 2 19)
                                                       2
                                                       ((x1 x7)
                                                        (caml-constr-get-field
                                                          (car (caml-constr-get-field
                                                                 (car x9)
                                                                 0))
                                                          0))
                                                       (cons (access_stream_157@trstream
                                                               x7)
                                                             '())))
                                                   '())
                                             (((translate_matching_84@match
                                                 (lambda (x11)
                                                   (caml-make-tag 9 19)))
                                               x2)
                                              (cons (caml-make-regular
                                                      (caml-make-tag 0 1)
                                                      2
                                                      (cons (caml-constr-get-field
                                                              (car (caml-constr-get-field
                                                                     (car x9)
                                                                     0))
                                                              1)
                                                            '())
                                                      ((caml-constr-get-field
                                                         x10
                                                         1)
                                                       ((x5 (caml-constr-get-field
                                                              x10
                                                              0))
                                                        (caml-make-regular
                                                          (caml-make-tag 0 1)
                                                          2
                                                          (cdr (caml-constr-get-field
                                                                 (car x9)
                                                                 0))
                                                          (caml-constr-get-field
                                                            (car x9)
                                                            1)))))
                                                    '())))
                                           ((x6 (caml-make-regular
                                                  (caml-make-tag 1 3)
                                                  1
                                                  x7))
                                            (cdr x9))))))
                                    (if (null? (cdr x9))
                                      (let ((x10 ((add_pat_to_env_200@tr_env x7)
                                                  (caml-constr-get-field
                                                    (car (caml-constr-get-field
                                                           (car x9)
                                                           0))
                                                    1))))
                                        (caml-make-regular
                                          (caml-make-tag 4 19)
                                          2
                                          (cons (caml-make-regular
                                                  (caml-make-tag 2 19)
                                                  2
                                                  ((x1 x7)
                                                   (caml-constr-get-field
                                                     (car (caml-constr-get-field
                                                            (car x9)
                                                            0))
                                                     0))
                                                  (cons (access_stream_157@trstream
                                                          x7)
                                                        '()))
                                                '())
                                          (((translate_matching_84@match
                                              (lambda (x11)
                                                raise_parse_failure_133@trstream))
                                            x2)
                                           (cons (caml-make-regular
                                                   (caml-make-tag 0 1)
                                                   2
                                                   (cons (caml-constr-get-field
                                                           (car (caml-constr-get-field
                                                                  (car x9)
                                                                  0))
                                                           1)
                                                         '())
                                                   ((caml-constr-get-field
                                                      x10
                                                      1)
                                                    ((x5 (caml-constr-get-field
                                                           x10
                                                           0))
                                                     (caml-make-regular
                                                       (caml-make-tag 0 1)
                                                       2
                                                       (cdr (caml-constr-get-field
                                                              (car x9)
                                                              0))
                                                       (caml-constr-get-field
                                                         (car x9)
                                                         1)))))
                                                 '()))))
                                      (staticfail1003))))
                                 (else
                                  (caml-make-regular
                                    (caml-make-tag 4 19)
                                    2
                                    (cons (access_stream_157@trstream x7) '())
                                    ((x5 (caml-make-regular
                                           (caml-make-tag 2 3)
                                           2
                                           (cons (caml-make-regular
                                                   (caml-make-tag 0 1)
                                                   2
                                                   (caml-constr-get-field
                                                     (car (caml-constr-get-field
                                                            (car x9)
                                                            0))
                                                     0)
                                                   (caml-make-tag 0 2))
                                                 '())
                                           x7))
                                     (caml-make-regular
                                       (caml-make-tag 0 1)
                                       2
                                       (cdr (caml-constr-get-field (car x9) 0))
                                       (caml-constr-get-field
                                         (car x9)
                                         1)))))))))))))
          (caml-make-regular
            (caml-make-tag 3 19)
            1
            ((x6 (caml-make-regular
                   (caml-make-tag 2 3)
                   2
                   (cons (caml-make-regular
                           (caml-make-tag 0 1)
                           2
                           #"%stream"
                           (caml-make-tag 0 2))
                         '())
                   x3))
             x4))))))
)
